#include <oxstd.h>
#include <arma.h>
#include <database.h>
#include <oxdraw.h>
#include <oxfloat.h>


main()
{

	format(5000);
	decl post=loadmat("c:/projects/active/sunspots/gauss1/post.fmt");
	post=post[.2*rows(post):][];
	print(quantilec(post));

	decl mupost=meanc(post);
	decl ind=selectifc(range(0,columns(mupost)-1),(mupost.!=0));
	post=post[][ind];
	mupost=quantilec(post);

	decl ind_ln=<0,1,3,4,5,6,10,11,12>;
	decl ind_lnr=<2,7,8>;
	decl ind_lnrx=<9>;
	
	decl posttr=post;
	posttr[][ind_ln]=log(post[][ind_ln]);
	posttr[][ind_lnr]=log(post[][ind_lnr]./(1-post[][ind_lnr]));
	posttr[][ind_lnrx]=log((1+post[][ind_lnrx])./(1-post[][ind_lnrx]));

	decl der1,der2;
	der1=der2=zeros(1,13);
	der1[ind_ln]=der2[ind_ln]=mupost[ind_ln];
	der1[ind_lnr]=mupost[ind_lnr].*(1-mupost[ind_lnr]);
	der2[ind_lnr]=mupost[ind_lnr].*(1-mupost[ind_lnr]).*(2-mupost[ind_lnr]);
	der1[ind_lnrx]=.5*(1-sqr(mupost[ind_lnrx]));
	der2[ind_lnrx]=-.5*mupost[ind_lnrx].*(1-sqr(mupost[ind_lnrx]));

	decl sc=loadmat("c:/projects/active/sunspots/gauss1/XXscores.fmt")[][ind];
	decl sctr=sc.*der1;
	decl priorhess=diagonal(loadmat("c:/projects/active/sunspots/gauss1/priorhess.fmt")[ind][ind]);
	decl priord=loadmat("c:/projects/active/sunspots/gauss1/mgradpfin.fmt")[ind][0]';

	decl priorhesstr=diag(priorhess.*sqr(der1)+der2.*priord);

	decl S=quantilec(posttr,<0.25,0.75>);
	S=diag((S[1][]-S[0][])/1.34896);
	decl thranks=posttr;
	decl rind=range(0,rows(thranks)-1)';
	for(decl i=0;i<columns(thranks);i++)
		thranks[sortbyc(posttr[][i]~rind,0)[][1]][i]=rind;

	decl Sigpost=S*2*sin((M_PI/6)*correlation(thranks))*S;
	
	decl sc2=sctr'sctr;
	decl SSand=Sigpost*(sc2+priorhesstr)*Sigpost;

	for(decl i=1;i<=3;i++){
		decl G=sctr[i:][]'sctr[0:rows(sc)-1-i][];
		sc2+=(1-i/4)*(G+G');
	}
	decl SSandNW=Sigpost*(sc2+priorhesstr)*Sigpost;

//	print((mupost|sqrt(diagonal(Sigpost)|diagonal(SSand)|diagonal(SSandNW)))');
	
	decl muposttr=quantilec(posttr);

	for(decl i=0;i<columns(post);i++){
		SetDrawWindow(sprint(i));
		DrawDensity(0,(posttr[][i]'),0,1,0,0);
		DrawDensity(0,(muposttr[i]+rann(1,rows(posttr))*S[i][i]),0,1,0,0);

		
		ShowDrawWindow();
	}
		
	decl aMOD=quantilec(post,<.025,.975>);
	decl aS=(muposttr+1.96*<-1;1>.*sqrt(diagonal(SSand)))|(muposttr+1.96*<-1;1>.*sqrt(diagonal(SSandNW)));
	aS[][ind_ln]=exp(aS[][ind_ln]);
	aS[][ind_lnr]=1 ./ (1+exp(-aS[][ind_lnr]));
	aS[][ind_lnrx]=(-1+exp(aS[][ind_lnrx]))./(1+exp(aS[][ind_lnrx]));

	print((aMOD|aS)');
	
}